<template>
  <div>
    <v-expansion-panels>
      <v-expansion-panel>
        <v-expansion-panel-header>Conexión</v-expansion-panel-header>
        <v-expansion-panel-content>
          <div class="pt-10">
            Conexión
            <v-select
              :items="connections"
              item-text="name"
              item-value="value"
              v-model="configuration.connection.value"
              label="Elige una conexión"
              single-line
              solo
              clearable
            ></v-select>
            Query Timeout
            <v-text-field
              placeholder="Query Timeout"
              v-model.number.trim="configuration.query_timeout"
              outlined
            ></v-text-field>
          </div>
        </v-expansion-panel-content>
      </v-expansion-panel>
      <v-expansion-panel>
        <v-expansion-panel-header>Parametros</v-expansion-panel-header>
        <v-expansion-panel-content>
          <Params :set-params="setParams" />
        </v-expansion-panel-content>
      </v-expansion-panel>
      <v-expansion-panel>
        <v-expansion-panel-header>SQL</v-expansion-panel-header>
        <v-expansion-panel-content>
          <div class="pt-10">
            <CodeMirror :set-plsql="setPlsql" />
            <div class="text-center mt-5">
              <v-btn
                tile
                depressed
                color="primary"
                :disabled="
                  !configuration.connection.value ||
                    !plsql ||
                    plsql === '' ||
                    isLoading
                "
                @click="execute"
                >Correr</v-btn
              >
            </div>
          </div>
        </v-expansion-panel-content>
      </v-expansion-panel>
      <v-expansion-panel>
        <v-expansion-panel-header>Salida</v-expansion-panel-header>
        <v-expansion-panel-content>
          <template v-if="output">
            <div class="pt-5">
              <div class="mb-5">
                <v-btn @click="clearOutput">Limpiar</v-btn>
              </div>
            </div>
            <v-card v-if="errorOut">
              <v-card-text>{{ output }}</v-card-text>
            </v-card>
            <v-card v-if="!errorOut">
              <v-toolbar>
                <v-toolbar-title>Variables</v-toolbar-title>
              </v-toolbar>
              <v-tabs :centered="true" vertical>
                <template
                  v-for="(itemSimple, indexItemSimple) in outVars.simple"
                >
                  <v-tab :key="'simple' + indexItemSimple">
                    <v-icon left>mdi-arrow-right-bold-box-outline</v-icon>
                    {{ itemSimple.name }}
                  </v-tab>
                </template>
                <template v-for="(itemGrid, indexItemGrid) in outVars.grids">
                  <v-tab :key="indexItemGrid">
                    <v-icon left>mdi-arrow-right-bold-box-outline</v-icon>
                    {{ itemGrid.name }}
                  </v-tab>
                </template>
                <template
                  v-for="(itemSimple, indexItemSimple) in outVars.simple"
                >
                  <v-tab-item :key="'simple' + indexItemSimple">
                    <v-tabs>
                      <v-tabs-slider></v-tabs-slider>
                      <v-tab>
                        Valor
                      </v-tab>
                      <v-tab-item>
                        {{ itemSimple.value }}
                      </v-tab-item>
                    </v-tabs>
                  </v-tab-item>
                </template>
                <template v-for="(itemGrid, indexItemGrid) in outVars.grids">
                  <v-tab-item :key="indexItemGrid">
                    <v-tabs>
                      <v-tabs-slider></v-tabs-slider>
                      <v-tab>
                        Valor
                      </v-tab>
                      <v-tab-item>
                        <div class="text-right mt-5 mb-5 mr-5">
                          <v-btn
                            color="secondary"
                            tile
                            depressed
                            @click="exportToJSON(itemGrid)"
                            >Exportar a JSON</v-btn
                          >
                          <v-btn
                            class="ml-5"
                            color="secondary"
                            tile
                            depressed
                            @click="exportToCSV(itemGrid)"
                            >Exportar a CSV</v-btn
                          >
                        </div>
                        <v-card>
                          <v-card-title>
                            Datos
                            <v-spacer></v-spacer>
                            <v-text-field
                              v-model="itemGrid.search"
                              append-icon="mdi-magnify"
                              label="Buscar"
                              single-line
                              hide-details
                            ></v-text-field>
                          </v-card-title>
                          <v-data-table
                            :loading="isLoading"
                            height="400"
                            fixed-header
                            :search="itemGrid.search"
                            :key="'grid' + indexItemGrid"
                            :headers="itemGrid.headers"
                            :items="itemGrid.rows"
                          ></v-data-table>
                        </v-card>
                      </v-tab-item>
                    </v-tabs>
                  </v-tab-item>
                </template>
              </v-tabs>
            </v-card>
          </template>
        </v-expansion-panel-content>
      </v-expansion-panel>
    </v-expansion-panels>
  </div>
</template>
<script>
import axios from "axios";
import Params from "@/views/secure/anonymus/Params.vue";
import CodeMirror from "@/views/secure/anonymus/CodeMirror.vue";
export default {
  name: "Component-Anonymus",
  components: {
    Params,
    CodeMirror
  },
  data() {
    return {
      connections: [],
      params: [],
      paramsFormated: [],
      errorFormat: true,
      configuration: {
        query_timeout: 30,
        connection: {
          value: null
        }
      },
      plsql: null,
      output: null,
      outVars: {},
      errorOut: false,
      isLoading: false
    };
  },
  methods: {
    paramsFormat() {
      let paramsParsed;
      try {
        paramsParsed = JSON.parse(this.params);
      } catch (error) {
        console.log();
      }
      if (paramsParsed) {
        const json = JSON.stringify(paramsParsed, null, 4);
        this.params = json;
        this.errorFormat = false;
        this.paramsFormated = JSON.parse(json);
      } else {
        this.errorFormat = true;
      }
    },
    getConnections() {
      const self = this;
      axios
        .get("oracle/connections")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setConnections(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    setConnections(connections) {
      this.connections = connections;
    },
    setParams(params) {
      this.params = params;
      this.paramsFormated = params;
    },
    setPlsql(plsql) {
      this.plsql = plsql;
    },
    execute() {
      this.clearOutput();
      this.isLoading = true;
      const self = this;
      if (this.configuration.query_timeout === "") {
        this.configuration.query_timeout = 0;
      }
      const params = {
        properties: this.configuration,
        register_parameters: this.paramsFormated,
        plsql: this.plsql
      };
      axios
        .post("oracle/execute", params)
        .then((response) => {
          if (response) {
            const data = response.data.data;
            if (data) {
              self.errorOut = false;
              self.setOuput(data);
            } else {
              self.output = response.data.error.message;
              self.errorOut = true;
              self.outVars = {};
            }
          }
        })
        .catch((error) => {
          self.output = error;
          console.log(error);
        })
        .finally(function() {
          self.isLoading = false;
        });
    },
    setOuput(output) {
      this.output = output;
      let outVars = {
        grids: [],
        simple: []
      };
      for (let index in output) {
        let item = output[index];
        let isArray = Array.isArray(item);
        if (isArray) {
          let headers = [];
          if (item.length >= 0) {
            let templateHeader = item[0];
            for (let header in templateHeader) {
              headers.push({ text: header, value: header });
            }
          }
          outVars.grids.push({
            search: null,
            name: index,
            rows: item,
            headers
          });
        } else {
          outVars.simple.push({ name: index, value: item });
        }
      }
      this.outVars = outVars;
    },
    exportToJSON(data) {
      let nameFile = data.name.toLowerCase() + ".json";
      const json = JSON.stringify(data.rows, null, 2);
      var a = document.createElement("a");
      var file = new Blob([json], { type: "application/json;charset=utf-8;" });
      a.href = URL.createObjectURL(file);
      a.download = nameFile;
      a.click();
    },
    convertToCSV(objArray) {
      const array =
        typeof objArray != "object" ? JSON.parse(objArray) : objArray;
      let str = "";
      for (let i = 0; i < array.length; i++) {
        let line = "";
        for (let index in array[i]) {
          if (line != "") line += ",";

          line += array[i][index];
        }
        str += line + "\r\n";
      }
      return str;
    },
    exportToCSV(data) {
      const headers = JSON.parse(JSON.stringify(data.headers));
      let finalHeaders = {};
      const items = JSON.parse(JSON.stringify(data.rows));
      if (headers) {
        for (let indexHeader in headers) {
          finalHeaders[headers[indexHeader].text] = headers[indexHeader].text;
        }
        items.unshift(finalHeaders);
      }
      const jsonObject = JSON.stringify(items);
      const csv = this.convertToCSV(jsonObject);
      let nameFile = data.name.toLowerCase() + ".csv";
      var a = document.createElement("a");
      var file = new Blob([csv], { type: "text/csv;charset=utf-8;" });
      a.href = URL.createObjectURL(file);
      a.download = nameFile;
      a.click();
    },
    clearOutput() {
      this.output = null;
      this.outVars = {};
    }
  },
  created() {
    this.getConnections();
  }
};
</script>
